
package de.ivu.elect.presentation.gruppeimgebiet;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.control.StimmenPoolExtendedDAOFactory;
import de.ivu.elect.business.ergebnis.control.StimmenPool;
import de.ivu.elect.business.gebietsbaum.boundary.GebietNichtAusgewaehltException;
import de.ivu.elect.business.gebietsbaum.boundary.GebietSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.gebietsbaum.control.GebietByGebietsartAndPositionComparator;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gruppe.entity.GruppeArt;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietExtendedDAO;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahlvorschlag.boundary.WahlvorschlagExtendedDAO;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.jee.presentation.status.OutputSeverity;
import de.ivu.elect.jee.presentation.status.StatusEntry;
import de.ivu.elect.presentation.AbstractElectStatusView;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.gebietsbaum.status.GebietsbaumSeparatorStatusEntry;
import de.ivu.elect.presentation.gebietsbaum.status.GebietsbaumStatusEntry;
import de.ivu.elect.presentation.gruppeimgebiet.status.GruppeImGebietStatusEntryFactory;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@RequestScoped
@OnlineHilfeId("337")
@Named(GruppeImGebietStatusView.COMPONENT_NAME)
@View(viewId = GruppeImGebietStatusView.VIEW_ID, useCase = UseCasePermission.GRUPPE_IM_GEBIET_STATUS)
@UseCaseSecure(UseCasePermission.GRUPPE_IM_GEBIET_STATUS)
public class GruppeImGebietStatusView extends AbstractElectStatusView<GebietsbaumStatusEntry> {

  private static final long serialVersionUID = 1L;

  public static final String VIEW_ID = "/gruppeimgebiet/gruppe-im-gebiet-status.xhtml";

  public static final String COMPONENT_NAME = "gruppeImGebietStatusView";

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  @Inject
  private transient GebietSessionSelect gebietSessionSelect;

  @Inject
  private transient GruppeImGebietExtendedDAO gruppeImGebietExtendedDAO;

  @Inject
  private transient GruppeImGebietStatusEntryFactory statusEntryFactory;

  @Inject
  private transient WahlvorschlagExtendedDAO wahlvorschlagExtendedDAO;

  @Inject
  private transient StimmenPoolExtendedDAOFactory stimmenPoolExtendedDAOFactory;

  private Map<Gebiet,  List<GruppeImGebiet>> gruppenInGebieten = null;

  public GruppeImGebietStatusView() {
    super();
  }

  @PreConditionCheck
  public String checkCondition() {
    if (!gebietSessionSelect.isSelected()) {
      throw new GebietNichtAusgewaehltException();
    }
    return null;
  }

  private Wahl getSelectedWahl() {
    return wahlSessionSelect.getEntity();
  }

  private Gebiet getSelectedGebiet() {
    return gebietSessionSelect.getEntity();
  }

  public void onGebietSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietSelectChangeEvent event) {
    reset();
  }

  public Gebiet getGebietDessenReihenfolgeAngezeigtWird() {
    Gebiet gebiet = getSelectedGebiet();
    while (gebiet != null && !gebiet.isWahlOderDirektwahlOderListenwahlgebietOderHatEntprechendesUntergebiet()) {
      gebiet = gebiet.getUebergeordnetesGebiet();
    }
    return gebiet;
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.GRUPPE_IM_GEBIET_ANZEIGEN)
  public String redirectTo(GebietsbaumStatusEntry gebietsbaumStatusEntry) {
    Gebiet gebiet = gebietsbaumStatusEntry.getGebiet();
    if (gebiet != null) {
      gebietSessionSelect.setEntity(gebiet);
    }
    return GruppeImGebietSearchView.VIEW_ID;
  }

  @Override
  protected List<GebietsbaumStatusEntry> bestimmeStatusEntriesInternal() {
    List<GebietsbaumStatusEntry> result = new ArrayList<>();
    Gebiet gebietSelected = getSelectedGebiet();
    if (gebietSelected != null) {

      Wahl wahl = gebietSelected.getWahl();
      Collection<Wahlvorschlag> alleWahlvorschlaege = wahlvorschlagExtendedDAO.findByWahl(wahl);

      StimmenPool vorperiodeStimmen = stimmenPoolExtendedDAOFactory.createStimmenPoolVorperiode(wahl);

      List<GruppeImGebiet> gruppenImGebiet = getGruppeImGebietByGebietAndGruppeArten(gebietSelected,
          GruppeArt.valuesPolitischeGruppeGruppeArt(), alleWahlvorschlaege, vorperiodeStimmen);
      result.add(statusEntryFactory.create(gebietSelected, gruppenImGebiet));
      ArrayList<Gebiet> untergebiete = new ArrayList<>(gebietSelected.getUntergeordneteGebiete());
      if (!untergebiete.isEmpty()) {
        result.add(new GebietsbaumSeparatorStatusEntry());
        addEntriesFuerUntergeordneteGebiete(result, untergebiete, alleWahlvorschlaege, vorperiodeStimmen);
      }
      entferneSeparatorAmEnde(result);
    }
    return result;
  }

  @Override
  protected AbstractGebietSecurityFilter<GebietsbaumStatusEntry> getGebietSecurityFilter() {
    return AbstractGebietSecurityFilter.createEntityMitGebietSecurityFilter(getEinsehenGebietSecurity());
  }

  /*
   * Durchlaufe Gebietsbaum in Form einer Breitensuche
   */
  private void addEntriesFuerUntergeordneteGebiete(List<GebietsbaumStatusEntry> result, List<Gebiet> gebiete,
      Collection<Wahlvorschlag> alleWahlvorschlaege, StimmenPool vorperiodeStimmen) {
    gebiete.sort(new GebietByGebietsartAndPositionComparator());
    List<Gebiet> untergebiete = new ArrayList<>();
    for (Gebiet gebiet : gebiete) {
      if (gebiet.isWahlOderDirektwahlOderListenwahlgebietOderHatEntprechendesUntergebiet()) {
        List<GruppeImGebiet> gruppenImGebiet = getGruppeImGebietByGebietAndGruppeArten(gebiet, GruppeArt.valuesPolitischeGruppeGruppeArt(),
            alleWahlvorschlaege, vorperiodeStimmen);
        result.add(statusEntryFactory.create(gebiet, gruppenImGebiet));
        untergebiete.addAll(gebiet.getUntergeordneteGebiete());
      }
    }
    if (!untergebiete.isEmpty()) {
      result.add(new GebietsbaumSeparatorStatusEntry());
      addEntriesFuerUntergeordneteGebiete(result, untergebiete, alleWahlvorschlaege, vorperiodeStimmen);
    }
  }

  private List<GruppeImGebiet> getGruppeImGebietByGebietAndGruppeArten(Gebiet gebiet, Collection<GruppeArt> gruppeArten,
      Collection<Wahlvorschlag> alleWahlvorschlaege, StimmenPool vorperiodeStimmen) {
    if (gruppenInGebieten == null) {
      gruppenInGebieten = gruppeImGebietExtendedDAO.findByWahl(getSelectedWahl()).stream().collect(Collectors.groupingBy(GruppeImGebiet::getGebiet));
    }

    return gruppenInGebieten.getOrDefault(gebiet, Collections.emptyList()).stream()
        .filter(gruppeImGebiet -> gruppeImGebiet.getGebiet().equals(gebiet) && gruppeArten.contains(gruppeImGebiet.getGruppeArt())
            && gruppeImGebiet.isRelevant(alleWahlvorschlaege, vorperiodeStimmen)).collect(Collectors.toList());
  }

  private void entferneSeparatorAmEnde(List<GebietsbaumStatusEntry> result) {
    if (result.get(result.size() - 1).isSeparator()) {
      result.remove(result.size() - 1);
    }
  }

  public Long getAnzahlGebieteUnvollstaendig() {
    return getStatusEntries().stream().filter(StatusEntry::isError).count();
  }

  public Long getAnzahlGebieteMitHinweis() {
    return getStatusEntries().stream().filter(StatusEntry::isWarn).count();
  }

  public OutputSeverity getStatusGesamt() {
    if (getAnzahlGebieteUnvollstaendig() > 0) {
      return OutputSeverity.ERROR;
    }
    if (getAnzahlGebieteMitHinweis() > 0) {
      return OutputSeverity.WARN;
    }
    return OutputSeverity.SUCCESS;
  }

  public OutputSeverity getStatusUnvollstaendig() {
    if (getAnzahlGebieteUnvollstaendig() > 0) {
      return OutputSeverity.ERROR;
    }
    return OutputSeverity.SUCCESS;
  }

  public OutputSeverity getStatusHinweise() {
    if (getAnzahlGebieteMitHinweis() > 0) {
      return OutputSeverity.WARN;
    }
    return OutputSeverity.SUCCESS;
  }
}
